// AxDialogControl.h : Declaration of the CAxDialogControl

#ifndef __AXDIALOGCONTROL_H_
#define __AXDIALOGCONTROL_H_

#include "resource.h"       // main symbols
#include <atlctl.h>


/////////////////////////////////////////////////////////////////////////////
// CAxDialogControl
class ATL_NO_VTABLE CAxDialogControl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IAxDialogControl, &IID_IAxDialogControl, &LIBID_SAMPLEAXDIALOGCONTROLVCLib>,
	public CComCompositeControl<CAxDialogControl>,
	public IPersistStreamInitImpl<CAxDialogControl>,
	public IOleControlImpl<CAxDialogControl>,
	public IOleObjectImpl<CAxDialogControl>,
	public IOleInPlaceActiveObjectImpl<CAxDialogControl>,
	public IViewObjectExImpl<CAxDialogControl>,
	public IOleInPlaceObjectWindowlessImpl<CAxDialogControl>,
	public IPersistStorageImpl<CAxDialogControl>,
	public ISpecifyPropertyPagesImpl<CAxDialogControl>,
	public IQuickActivateImpl<CAxDialogControl>,
	public IDataObjectImpl<CAxDialogControl>,
	public IProvideClassInfo2Impl<&CLSID_AxDialogControl, NULL, &LIBID_SAMPLEAXDIALOGCONTROLVCLib>,
	public CComCoClass<CAxDialogControl, &CLSID_AxDialogControl>
{
public:
	CAxDialogControl()
	{
		m_bWindowOnly = TRUE;
		CalcExtent(m_sizeExtent);
	}

DECLARE_REGISTRY_RESOURCEID(IDR_AXDIALOGCONTROL)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CAxDialogControl)
	COM_INTERFACE_ENTRY(IAxDialogControl)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(CAxDialogControl)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CAxDialogControl)
	CHAIN_MSG_MAP(CComCompositeControl<CAxDialogControl>)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

BEGIN_SINK_MAP(CAxDialogControl)
	//Make sure the Event Handlers have __stdcall calling convention
END_SINK_MAP()

	STDMETHOD(OnAmbientPropertyChange)(DISPID dispid)
	{
		if (dispid == DISPID_AMBIENT_BACKCOLOR)
		{
			SetBackgroundColorFromAmbient();
			FireViewChange();
		}
		return IOleControlImpl<CAxDialogControl>::OnAmbientPropertyChange(dispid);
	}



// IViewObjectEx
	DECLARE_VIEW_STATUS(0)

// IAxDialogControl
public:

	enum { IDD = IDD_AXDIALOGCONTROL };
};

#endif //__AXDIALOGCONTROL_H_
